# New SPS injection optimisation studies

This repository contains code and studies for the hierarchical optimisation framework for designing a new Super Proton Synchrotron (SPS) injection system at CERN. The injection of particles into the SPS happens within a single turn, placing the particles on the orbit of the circulating beam. Some special electromagnetic elements are used for the injection and extraction. A *kicker* magnet is a fast-pulsed dipole magnet that can reach the maximum field in less than one revolution, typically within hundreds of nanoseconds. A *septum* magnet is a special insertion magnet that define the borderline between the ring and the transfer line (TL). The kicker and setum magnets are illustrated in the figure below. A more detailed technical background on the injection system can be found in my [Uppsala University report](http://urn.kb.se/resolve?urn=urn:nbn:se:uu:diva-468033). 

![](images/sps_single_turn_injection.png)

The main challenge is to find a sequence of magnets that injects the beam in a stable manner without losses, using minimal magnet resources. We optimise the number of magnets at the higher level, and the magnet strengths and positions for the given configuration at the lower level. This multi-level optimisation is called *hierarchical optimisation*. The hierarchical optimisation is divided into two levels:
* **Low-level optimisation**: adjusts  the  septa (MSI)  and kicker (MKP) magnet strengths and positions to obtain a stable preserved beam for a given magnet configuration for given optics (either Q20, Q26 or SFTPRO).
* **High-level optimisation**: optimises the number *n1* of magnet modules per MKP vacuum tank, and the number *n2* of total vacuum tanks. Contains the nested low-level optimiser. 

The low-level optimiser varies the MSI/MKP magnet strengths and positions to minimise objective function 2, which is the square of the horizontal beam position and momentum at the end of the SPS injection sequence. Hence, magnet strengths and positions constitute *actors*, or degrees of freedom (DOF). Additional penalities are added if the minimum acceptance is too low (if the beam envelope hits the mechanical aperture) or if the beam is not safely dumped into the beam dump TBSJ. The low-level optimiser uses the adaptive Nelder-Mead method in `scipy.optimize.minimize`. The high-level optimiser uses the actors *n1* and *n2* (number of MKP modules and vacuum tanks) to minimise objective function 1, which the square of the integrated magnetic field *Bdl* and the magnetic field *B* of the kickers. This level uses a genetic algorithm from `pymoo`, inspired by the process of natural selection to select eligible candidate solutions in search space. 

The main flow of the hierarchical optimisation is illustrated the figure below. The meta-optimiser (located in the wrapper function `runOpt_sps_injection_meta_optimisation_pymoo.py`) first creates a global environment object from the module `sps_injection_opt_env_global.py`, whose `step` method takes the number of MKP magnet modules *n1* and of tanks *n2* as input and returns the value of objective function 1. As a second step, the global environment creates an environment object for each optics (from the module `sps_injection_opt_env_low_level.py`) with the given *n1* and *n2* for its injection sequence, and minimises objective function 2 by varying the MSI/MKP magnet strengths and positions. As a third step, the global environment selects the optics environment with the highest integrated MKP field value *Bdl*, as this will suffice for the other optics too. The global environment then re-optimises the other environments with the magnet positions from the optics with the highest *Bdl*, using the `sps_injection_opt_env_low_level_fixed_magnets.py` module. In the last step, the `step` method of the global environment returns the value of objective function 1 to the meta-optimiser. This whole iteration (step 1-4 below) corresponds to one step of the genetic algorithm on the higher level. If MAD-X crashes at any point throughout the process, the `reset` method of the low-level environment is called and a new MAD-X process is spawned with the starting magnet configuration. 

![](images/visualization_optimiser.png)

Before performing the hierarchical optimisation process, it is advisable to perform a smaller sweep over the high-level search space to generate initial conditions for different parameter combinations, as the low-level optimisation is often highly dependent on picking suitable initial conditions. This is done in the script `generate_initial_conditions_sps_injection.py`. Once this has been  done, the hierarchical optimisation framework saves the low-level results to be used as initial conditions if the same parameter combination is searched for again.

The module `acc_phy_lib_elias.py` contains my personal collection of accelerator physics functions to facilitate calculations and operations, for instance to handle MAD-X via the Python interface. These functions are compatible with different accelerator systems, but also contains functions tailored specifically for the SPS injection. 

